Package org.apache.sysds.runtime.meta

## Class DataCharacteristics

- java.lang.Object
- - org.apache.sysds.runtime.meta.DataCharacteristics

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `MatrixCharacteristics`, `TensorCharacteristics`

    public abstract class DataCharacteristics
    extends Object
    implements Serializable

See Also:
  Serialized Form

### Constructor Summary

Constructors
`DataCharacteristics()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract boolean` `colsKnown()`
`abstract boolean` `dimsKnown()`
`abstract boolean` `dimsKnown​(boolean includeNnz)`
`abstract boolean` `equalDims​(Object anObject)`
`abstract boolean` `equals​(Object anObject)`
`int` `getBlocksize()`
`abstract long` `getCols()`
`abstract long` `getDim​(int i)`
`long[]` `getDims()`
`abstract int[]` `getIntDims()`
`abstract long` `getLength()`
`abstract long[]` `getLongDims()`
`abstract long` `getNonZeros()`
`abstract long` `getNonZerosBound()`
`long` `getNumBlocks()`
`abstract long` `getNumBlocks​(int i)`
`abstract long` `getNumColBlocks()`
`abstract int` `getNumDims()`
`abstract long` `getNumRowBlocks()`
`abstract long` `getRows()`
`abstract double` `getSparsity()`
`abstract int` `hashCode()`
`boolean` `isNoEmptyBlocks()`
`abstract boolean` `isUltraSparse()`
`abstract boolean` `mightHaveEmptyBlocks()`
`abstract boolean` `nnzKnown()`
`abstract boolean` `rowsKnown()`
`abstract DataCharacteristics` `set​(long[] dims, int blocksize)`
`abstract DataCharacteristics` `set​(long[] dims, int blocksize, long nnz)`
`abstract DataCharacteristics` `set​(long nr, long nc, int blen)`
`abstract DataCharacteristics` `set​(long nr, long nc, int blen, long nnz)`
`abstract DataCharacteristics` `set​(DataCharacteristics that)`
`DataCharacteristics` `setBlocksize​(int blen)`
`abstract DataCharacteristics` `setCols​(long clen)`
`abstract DataCharacteristics` `setDim​(int i, long dim)`
`abstract DataCharacteristics` `setDimension​(long nr, long nc)`
`abstract DataCharacteristics` `setDims​(long[] dims)`
`DataCharacteristics` `setNoEmptyBlocks​(boolean flag)`
`abstract DataCharacteristics` `setNonZeros​(long nnz)`
`abstract DataCharacteristics` `setNonZerosBound​(long nnz)`
`abstract DataCharacteristics` `setRows​(long rlen)`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DataCharacteristics

    public DataCharacteristics()

### Method Detail

#### set

    public abstract DataCharacteristics set​(long nr,
                                            long nc,
                                            int blen)

#### set

    public abstract DataCharacteristics set​(long nr,
                                            long nc,
                                            int blen,
                                            long nnz)

#### set

    public abstract DataCharacteristics set​(long[] dims,
                                            int blocksize)

#### set

    public abstract DataCharacteristics set​(long[] dims,
                                            int blocksize,
                                            long nnz)

#### set

    public abstract DataCharacteristics set​(DataCharacteristics that)

#### getRows

    public abstract long getRows()

#### setRows

    public abstract DataCharacteristics setRows​(long rlen)

#### getCols

    public abstract long getCols()

#### setCols

    public abstract DataCharacteristics setCols​(long clen)

#### getLength

    public abstract long getLength()

#### getBlocksize

    public int getBlocksize()

#### setBlocksize

    public DataCharacteristics setBlocksize​(int blen)

#### setNoEmptyBlocks

    public DataCharacteristics setNoEmptyBlocks​(boolean flag)

#### isNoEmptyBlocks

    public boolean isNoEmptyBlocks()

#### getNumBlocks

    public long getNumBlocks()

#### getNumRowBlocks

    public abstract long getNumRowBlocks()

#### getNumColBlocks

    public abstract long getNumColBlocks()

#### setDimension

    public abstract DataCharacteristics setDimension​(long nr,
                                                     long nc)

#### getNumDims

    public abstract int getNumDims()

#### getDim

    public abstract long getDim​(int i)

#### getDims

    public long[] getDims()

#### getLongDims

    public abstract long[] getLongDims()

#### getIntDims

    public abstract int[] getIntDims()

#### setDim

    public abstract DataCharacteristics setDim​(int i,
                                               long dim)

#### setDims

    public abstract DataCharacteristics setDims​(long[] dims)

#### getNumBlocks

    public abstract long getNumBlocks​(int i)

#### setNonZeros

    public abstract DataCharacteristics setNonZeros​(long nnz)

#### getNonZeros

    public abstract long getNonZeros()

#### setNonZerosBound

    public abstract DataCharacteristics setNonZerosBound​(long nnz)

#### getNonZerosBound

    public abstract long getNonZerosBound()

#### getSparsity

    public abstract double getSparsity()

#### dimsKnown

    public abstract boolean dimsKnown()

#### dimsKnown

    public abstract boolean dimsKnown​(boolean includeNnz)

#### rowsKnown

    public abstract boolean rowsKnown()

#### colsKnown

    public abstract boolean colsKnown()

#### nnzKnown

    public abstract boolean nnzKnown()

#### isUltraSparse

    public abstract boolean isUltraSparse()

#### mightHaveEmptyBlocks

    public abstract boolean mightHaveEmptyBlocks()

#### equalDims

    public abstract boolean equalDims​(Object anObject)

#### equals

    public abstract boolean equals​(Object anObject)

Overrides:
  `equals` in class `Object`

#### hashCode

    public abstract int hashCode()

Overrides:
  `hashCode` in class `Object`